# This file is part of 'Cut The Crap (CTC)'
# Copyright 1999-2000 Constantinos A. Kotsokalis <ckotso@cs.ntua.gr>
#
# CTC is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# CTC is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with CTC; see the file COPYING. If not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#

import asynchat, string, urlparse, re
import server_sock, mdebug

class client_sock(asynchat.async_chat):

	debug = 0

	def __init__(self, conn, config, errobj):
		asynchat.async_chat.__init__(self, conn)
		self.set_terminator('\r\n\r\n')
		self.config = config
		self.errobj = errobj
		self.slist = []
		self.send_buff = ''
		self.do_post = 0
		self.clre = re.compile("Content-length: .*", re.I)
		self.tmpbuff = ''


	def collect_incoming_data(self, buff):
		mdebug.mdebug(0, "Reading data from client socket " + `self.socket`)
		self.send_buff = string.join((self.send_buff, buff), '')
		if self.do_post:
			self.tmpbuff = string.join((self.tmpbuff, buff), '')
			if len(self.tmpbuff) == self.numbytes:
				self.found_terminator()


	def found_terminator(self):
		if string.find(self.send_buff, "POST")==0 or \
							string.find(self.send_buff, "PUT")==0:
			if not self.do_post:
				self.do_post = 1
				cl = self.clre.search(self.send_buff)
				clstr = cl.string[cl.start():cl.end()]
				self.numbytes = string.atoi(string.split(clstr)[1])
				self.send_buff = string.strip(self.send_buff)+"\r\n\r\n"
				return
			else:
				self.do_post = 0
		mdebug.mdebug(0, "Client socket " + `self.socket` + " found terminator")
		pass_url = string.split(self.send_buff)[1]
		mdebug.mdebug(0, "Client socket " + `self.socket` + " asked for URL " + pass_url)
		host, port, url = self.host_port_url(pass_url)
		if url == "/_CTC-stuff/CTC.gif":
			mdebug.mdebug(0, "Returning blank gif to client socket " + `self.socket`)
			self.push(self.config.ctc_gif)
			self.srv_closed()
		elif self.config.zaplet_engine.urlblocker(host, url):
			mdebug.mdebug(0, "Returning CTC gif to client socket " + `self.socket`)
			self.push(self.config.return_gif)
			self.srv_closed()
		else:
			self.send_buff = string.strip(self.send_buff)+"\r\n\r\n"
			ip = self.config.name_cache.name_check(host)

			if self.config.parent_proxy_host == '' or self.config.parent_proxy_port == -1 or self.config.noproxy.no_proxy(ip):
				mdebug.mdebug(0, "Connecting to "+host+":"+`port`+url+" "+pass_url)
				ss = self.make_srv_conn(pass_url, url, host, ip, port)
			else:
				mdebug.mdebug(0, "Connecting to parent proxy for "+url+" "+pass_url)
				if self.config.parent_proxy_ip == self.config.parent_proxy_host:
					self.config.parent_proxy_ip = self.config.name_cache.name_check(self.config.parent_proxy_host)
				ss = self.make_srv_conn(pass_url, pass_url, self.config.parent_proxy_host, self.config.parent_proxy_ip, self.config.parent_proxy_port)
				if ss.error_occured:
					mdebug.mdebug(0, "Connecting to "+host+":"+`port`+url+" "+pass_url)
					ss = self.make_srv_conn(pass_url, url, host, ip, port)

		self.send_buff = ''


	def make_srv_conn(self, pass_url, url, host, ip, port):
		if pass_url != url:
			self.send_buff = string.replace(self.send_buff, pass_url, url, 1)
		ss = server_sock.server_sock(host, ip, port, self.send_buff, self)
		mdebug.mdebug(0, "Client socket " + `self.socket` + "invoking server connection " + `ss.socket` + " to " + host + " for URL " + url)
		if not ss.error_occured:
			mdebug.mdebug(0, "No error - adding " + `ss.socket` + " to " + `self.socket` + " server list")
			self.slist.append(ss)
			mdebug.mdebug(0, "Server list for " + `self.socket` + " is " + `self.slist`)
		return ss


	def handle_close(self):
		for srv in self.slist:
			srv.close_by_client = 1
			mdebug.mdebug(0, "Client socket " + `self.socket` + " closing - invoking close on server socket " + `srv.socket`)
			srv.handle_close()
		mdebug.mdebug(0, "Client socket " + `self.socket` + " shutting down")
		self.close()


	def srv_closed(self):
		mdebug.mdebug(0, "srv_closed() invoked for client socket " + `self.socket`)
		if not len(self.slist):
			self.close_when_done()


	def host_port_url(self, arg):
		url_tuple = urlparse.urlparse(arg)
		host_port = url_tuple[1]
		tokens = string.split(host_port, '@')
		if len(tokens) == 2:
			host_port = tokens[1]
		tokens = string.split(host_port, ':')
		if len(tokens) == 2:
			host = tokens[0]
			port = string.atoi(tokens[1])
		else:
			host = tokens[0]
			port = 80
		url = url_tuple[2]
		if not len(url):
			url = '/';
		if len(url_tuple[3]):
			url = url + ';' + url_tuple[3]
		if len(url_tuple[4]):
			url = url + '?' + url_tuple[4]

		return host, port, url


	def push(self, buff):
		if self.fileno() != -1:
			mdebug.mdebug(0, "Client pushing data")
			asynchat.async_chat.push(self, buff)


	def log(self, msg):
		pass



